-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- DISCLAIMER - Execute at your own risk. Read this script and thoroughly test first!!!
--
-- Written by Kimberly L. Tripp of SYSolutions, Inc.
-- For more code samples go to http://www.sqlskills.com
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

USE CREDIT
go

CREATE INDEX MemberLastName ON Member(LastName)
CREATE INDEX MemberFirstName ON Member(FirstName)
go

-- View information about indexes:
exec sp_helpindex member
-- or acces the system tables to access info:
SELECT object_name(id) AS TableName,
	indid AS IndexID,
	name AS IndexName
 FROM dbo.sysindexes WHERE ID = object_id('member') 
go
sp_spaceused member, true
go
SET STATISTICS IO ON
go

SELECT Member_No, FirstName, Region_No
FROM Member 
WHERE FirstName LIKE 'K%'   -- guess 1/26 of table
        AND Region_No > 6 -- guess 1/3 of table
        AND Member_No < 5000  -- 1/2 of table
--index fname, member_no 1/26 * 1/2 = 1/52
--index region_no, member_no 1/3 * 1/2 = 1/6

-- SELECT Member_No, FirstName, Region_No
-- FROM Member (index (MemberFirstName, memberregion2))
-- WHERE FirstName LIKE 'K%'   -- guess 1/26 of table
--         AND Region_No > 6 -- guess 1/3 of table
--         AND Member_No < 5000  -- 1/2 of table

SELECT Member_No, FirstName, Region_No
FROM Member (index = MemberFirstName)
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No
FROM Member (index = member_region_link)
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

-- When forcing multiple indexes - order may be relevant
SELECT Member_No, FirstName, Region_No
FROM Member (index (MemberFirstName, member_region_link))
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No
FROM Member (index (member_region_link, MemberFirstName))
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000


CREATE INDEX testind2 ON member(firstname, region_no, member_no)
CREATE INDEX testind2 ON member(firstname, region_no) -- member_no is CL

SELECT Member_No, FirstName, Region_No
FROM Member -- best choice no matter what version
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000
go
SELECT Member_No, FirstName, Region_No
FROM Member (index (MemberFirstName, member_region_link))
	-- not possible until 7.0
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000
go
SELECT Member_No, FirstName, Region_No
FROM Member (index (0))
	-- in 6.5 - with these indexes...a table scan would have been the choice
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

-- What if our index doesn't cover!

SELECT Member_No, FirstName, Region_No, phone_no
FROM Member 
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No, phone_no
FROM Member (index = MemberFirstName)
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No, phone_no
FROM Member (index = member_region_link)
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No, phone_no
FROM Member (index (MemberFirstName, member_region_link))
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No, phone_no
FROM Member (index (member_region_link, MemberFirstName))
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000

SELECT Member_No, FirstName, Region_No, phone_no
FROM Member (index (testind2))
WHERE FirstName LIKE 'K%' 
        AND Region_No > 6 AND Member_No < 5000
